[ostree] core: Fix checksum for symlinks walking off into uninitialized memory



commit d0b3a07cf10cf76aecfc86b2fcc6fc0bd3aa6cc1
Author: Colin Walters <walters verbum org>
Date:   Wed Oct 26 18:33:33 2011 -0400

    core: Fix checksum for symlinks walking off into uninitialized memory

 src/libostree/ostree-core.c   |    7 ++++---
 tests/t0009-commit-symlink.sh |   35 +++++++++++++++++++++++++++++++++++
 2 files changed, 39 insertions(+), 3 deletions(-)
---
diff --git a/src/libostree/ostree-core.c b/src/libostree/ostree-core.c
index 1a9a76b..d92681b 100644
--- a/src/libostree/ostree-core.c
+++ b/src/libostree/ostree-core.c
@@ -224,13 +224,14 @@ ostree_stat_and_checksum_file (int dir_fd, const char *path,
   else if (S_ISLNK(stbuf.st_mode))
     {
       symlink_target = g_malloc (PATH_MAX);
-
-      if (readlinkat (dir_fd, basename, symlink_target, PATH_MAX) < 0)
+      
+      bytes_read = readlinkat (dir_fd, basename, symlink_target, PATH_MAX);
+      if (bytes_read < 0)
         {
           ot_util_set_error_from_errno (error, errno);
           goto out;
         }
-      g_checksum_update (content_sha256, (guint8*)symlink_target, strlen (symlink_target));
+      g_checksum_update (content_sha256, (guint8*)symlink_target, bytes_read);
     }
   else if (S_ISCHR(stbuf.st_mode) || S_ISBLK(stbuf.st_mode))
     {
diff --git a/tests/t0009-commit-symlink.sh b/tests/t0009-commit-symlink.sh
new file mode 100755
index 0000000..47e956d
--- /dev/null
+++ b/tests/t0009-commit-symlink.sh
@@ -0,0 +1,35 @@
+#!/bin/bash
+#
+# Copyright (C) 2011 Colin Walters <walters verbum org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+#
+# Author: Colin Walters <walters verbum org>
+
+set -e
+
+. libtest.sh
+
+echo "1..2"
+
+setup_test_repository2
+
+ostree checkout $ot_repo HEAD $test_tmpdir/checkout2-head
+cd $ht_files
+ln -s foo bar
+ostree commit $ot_repo -s "Add a symlink" -b "To test it" --add=bar
+echo "ok commit symlink"
+ostree fsck $ot_repo
+echo "ok fsck"



[Date Prev][Date Next]   [Thread Prev][Thread Next]   [Thread Index] [Date Index] [Author Index]